<copyright> Meta TOM tom parser.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996-2000 Pieter J. Schoenmakers.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: ParseTom.t,v 1.22 2000/06/27 17:15:19 tiggr Exp $</id>
    </copyright>

implementation class
ParseTom extension tm

end;

implementation instance
ParseTom extension tm
{
  <doc> The output filter we are using.  </doc>
  public mutable Output output;

  <doc> The supers introduced by this extension.  </doc>
  MutableIndexed supers;

  <doc> Iff {TRUE}, the documentation possibly present at the end of the
      start of a class or instance, is actually method documentation of
      the first method.  </doc>
  public boolean doc_method_p;

  <doc> Iff {TRUE}, do not print out private methods: only print out
      public parts of the class interface.  </doc>
  mutable boolean hide_private_methods;
}

void
  metaVar (int, Type, String) (qualifiers, type, name)
{
  [output metaVar (qualifiers, type, name)];
}

redefine void
  addConst String c
     value Expression e
{
  [output constant c value e];
}

redefine Expression
  attributeNamed String name
{
  = Any ([[Named alloc] initWithName name]);
}

redefine void
  finishMethodDecl CustomMethod m
{
  if (hide_private_methods && [Qualified isPrivate [m qualifiers]])
    [output savedDocumentation];
  else
    [output finishMethod m];
}

<doc> Return an object for an expression like {selector (void foo)}.
    Default implementation does nothing.  </doc>
redefine SelectorConstant
  selectorWithNameParts MutableArray name_parts
		  types (Type, MutableArray) (return_type, arg_types)
{
  = [SelectorConstant withNameParts name_parts
		      types (return_type, arg_types)];
}

redefine void
  startExtension mu.Extension ext
       interface boolean is_interface
{
  supers = nil;
  [output startExtension ext interface is_interface];
}

redefine void
  startMetaVars
{
  [output startMetaVars];
}

redefine void
  finishFile
{
  [output finishFile];
}

redefine void
  finishMetaVars
{
  [output finishMetaVars];
}

redefine void
  startMethods
{
  [output startMethods];
}

void
  finishMethods
{
  [output finishMethods];
}

redefine void
  startMethodBody CustomMethod m
{
  if (hide_private_methods && [Qualified isPrivate [m qualifiers]])
    [output savedDocumentation];
  else
    [output finishMethod m];
}

redefine void
  addSuper Meta meta
     shift boolean instance_only
{
  if (!supers)
    supers = [MutableObjectArray new];
  [supers add meta];
}

redefine void
  finishSupers
{
  if (supers != nil)
    [output doSupers supers];
}

redefine void
  willStartExtension
{
  doc_method_p = ![LexTom (lex) documentation];
}

Expression
   monop int op
    with All shs
  postp: boolean postfix = NO
pre
  shs != nil
{
  = [[UnresolvedOperatorInvocation alloc]
      initWithReceiver nil arguments [MutableObjectArray with shs] operator op
      postfixed: postfix];
}

Expression
  binop int op
   with (All, All) (lhs, rhs)
pre
  lhs != nil && rhs != nil
{
  = [[UnresolvedOperatorInvocation alloc]
      initWithReceiver nil arguments [MutableObjectArray with (lhs, rhs)]
      operator op];
}

Expression
  triop int op
   with (All, All, All) (lhs, mhs, rhs)
pre
  lhs != nil && mhs != nil && rhs != nil
{
  = [[UnresolvedOperatorInvocation alloc]
      initWithReceiver nil arguments [MutableObjectArray with (lhs, mhs, rhs)]
      operator op];
}

end;
